/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.action;

import java.util.Date;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.utils.DateUtil;
import jp.mosp.common.utils.StringUtil;
import jp.mosp.common.utils.VariousUtil;
import jp.mosp.kintai.common.action.MosPWorkflowAction;
import jp.mosp.kintai.common.part.KintaiApprovalPart;
import jp.mosp.kintai.common.part.KintaiCommonPart;
import jp.mosp.kintai.dto.MScheduleDto;
import jp.mosp.kintai.dto.MSyukkinboDto;
import jp.mosp.kintai.vo.AttendanceQuitCardVo;

/**
 * @author yoshida
 *
 */
public class AttendanceQuitCardAction extends MosPWorkflowAction {
	
	// コマンド
	/**
	 * 
	 */
	public static final String	CMD_QUIT_CARD_SHOW		= "K1110";
	private static final String	CMD_QUIT_CARD_REGIST	= "K1112";
	private static final String	CMD_QUIT_CARD_DELETE	= "K1113";
	private static final String	CMD_QUIT_CARD_DRAFT		= "K1114";
	private static final String	CMD_QUIT_CARD_REFLECT	= "K1115";
	private static final String	CMD_QUIT_CARD_CALCULATE	= "K1116";
	

	/**
	 * コンストラクタ
	 */
	public AttendanceQuitCardAction() {
		super();
	}
	
	public void action() throws Exception {
		// VOの取得
		prepareVo();
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_QUIT_CARD_SHOW)) {
			// 選択
			select();
		} else if (cmd.equals(CMD_QUIT_CARD_REGIST)) {
			// 登録
			regist(false);
		} else if (cmd.equals(CMD_QUIT_CARD_DELETE)) {
			// 削除
			delete();
		} else if (CMD_QUIT_CARD_DRAFT.equals(cmd)) {
			// 下書き
			regist(true);
		} else if (CMD_QUIT_CARD_REFLECT.equals(cmd)) {
			// 予定の反映
			reflect();
		} else if (CMD_QUIT_CARD_CALCULATE.equals(cmd)) {
			// 集計
			runCalc();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new AttendanceQuitCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		AttendanceQuitCardVo vo = (AttendanceQuitCardVo)getVo();
		// ユーザー情報取得
		getInfo(user.getUserId());
		// 手当一覧
		vo.aryAllowance = getMosPCodeArray(CommonConst.TID_ALLOWANCE_NAME);
		// 勤務形態一覧
		vo.aryWorkType = part().worktype().getWorkTypeInfoArrayWithHoliday();
		// 退勤時半休区分プルダウン
		vo.aryPltHalfHoliday = getHalfHolidayArray();
		// 早退理由プルダウン
		vo.aryPltLeaveEarlyReason = getReasonCodeArray(CommonConst.TID_LEAVE_EARLY_REASON);
		// 早退証明書プルダウン
		vo.aryPltLeaveEarlyCertificate = getMosPCodeArray(CommonConst.TID_LEAVE_EARLY_CERTIFICATE);
		// 勤怠管理コマンド
		setSubTitleMenu();
	}
	
	@Override
	protected void select() throws Exception {
		AttendanceQuitCardVo vo = (AttendanceQuitCardVo)getVo();
		// 表示の準備
		setAttendanceInfo();
		// 勤怠検索
		MSyukkinboDto dto = kintai().getSyukkinboInfo(vo.getHidKCode(), vo.getHidDate(), false);
		// データの存在確認
		chkExist(dto);
		if (StringUtil.isNull(dto.getTaJikoku())) {
			// 退勤項目無し
			vo.initFields();
		} else {
			// 退勤項目有り
			// VOに情報を設定
			vo.setFields(dto);
			// 下書き
			if (!KintaiApprovalPart.isDraft(dto)) {
				vo.setDraft(false);
			}
		}
		// 表示モードのセット
		setMode(dto);
		// ラベル表示のセット
		vo.setLabelInfo(dto);
		// 時間外警告対応
		setOverTimeCaution(vo.getHidKCode(), DateUtil.convStringDateToDate(vo.getHidDate()));
	}
	
	/**
	 * 退勤登録
	 * @param isDraft	下書きフラグ
	 * @throws Exception	例外処理が発生した場合
	 */
	private void regist(boolean isDraft) throws Exception {
		AttendanceQuitCardVo vo = (AttendanceQuitCardVo)getVo();
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		MSyukkinboDto dto = kintai().getSyukkinboInfo(vo.getHidKCode(), vo.getHidDate(), true);
		// 勤怠検索
		if (VariousUtil.isNull(dto)) {
			// 勤怠一覧へ戻る(勤怠データが無い場合)
			String errMessage = getMessage(CommonConst.MSG_NO_ATTENDANCE, "");
			addErrMessage(errMessage);
			setNextCmd(AttendanceListAction.CMD_ATTENDANCE_LIST_RE_SEARCH);
			throw new MospException(CommonConst.EX_NO_ATTENDANCE, errMessage);
		} else {
			// 承認済みの場合はメッセージ表示、登録不可
			if (KintaiApprovalPart.isApproved(dto)) {
				// メッセージ設定
				setMessage(getMessage(CommonConst.MSG_ALREADY_APPROVED, getMessageDate(dto)));
			} else {
				// UPDATE
				// 排他確認
				chkExclusive(dto, kintai().getSyukkinboInfo(dto.getKCode(), dto.getHizuke(), true));
				// VOの値をセット
				vo.setDtoFields(dto);
				// 下書き判断
				if (isDraft) {
					dto.setSnRiyuu(CommonConst.CODE_DRAFT);
				}
				boolean updateFlag = true;
				Date targetDate = DateUtil.convStringDateToDate(dto.getHizuke());
				// 午後半休の場合、残日数をチェックする。
				if (KintaiCommonPart.isQuitHalfHoliday(dto)) {
					if (!part().holidayRequest().isApprovedPaidHolidayRequestQuitHalf(dto)) {
						updateFlag = checkRemainPaidHoliday(dto.getKCode(), targetDate, CommonConst.NUM_HALF_DAY, 0);
					}
				}
				// 時間外代休(半日)の場合、残日数をチェックする。
				if (part().mospcode().useSubstituteHolidayFunction() && KintaiCommonPart.isOverTimeSubHolidayQuit(dto)) {
					if (!part().holidayRequest().isApprovedSubstituteHolidayRequestQuitHalf(dto)) {
						updateFlag = checkRemainSubstitute(dto.getKCode(), targetDate, CommonConst.NUM_HALF_DAY);
					}
				}
				if (updateFlag) {
					// 午前半休、午後半休、時間単位の年休の承認がある場合、反映
					margeHolidayRequest(dto);
					// 自動計算
					runAutoQuitCalc(dto);
					// 更新
					syukkinboDao().update(dto);
					// メッセージ設定
					setMessage(getMessage(MospConst.MSG_UPDATE, ""));
				}
			}
		}
		// コミット
		commit();
		// 勤怠一覧へ遷移
		setNextCmd(AttendanceListAction.CMD_ATTENDANCE_LIST_RE_SEARCH);
	}
	
	/**
	 * 予定の反映
	 * @throws Exception	例外処理が発生した場合
	 */
	private void reflect() throws Exception {
		AttendanceQuitCardVo vo = (AttendanceQuitCardVo)getVo();
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		String kCode = vo.getHidKCode();
		String strTargetDate = vo.getHidDate();
		MScheduleDto dto = part().kintai().getScheduleInfo(kCode, strTargetDate);
		if (VariousUtil.isNull(dto)) {
			MSyukkinboDto syukkinboDto = kintai().getSyukkinboInfo(kCode, strTargetDate);
			dto = kintai().createScheduleInfo(part().human().getBasisInfo(kCode),
					DateUtil.convStringDateToDate(strTargetDate), syukkinboDto.getKinmu());
		}
		if (KintaiCommonPart.isAvailableWorkType(dto)) {
			MSyukkinboDto syukkinboDto = KintaiCommonPart.copyToSyukkinbo(dto);
			vo.setDtoFields(syukkinboDto);
			syukkinboDto.setTaJikoku(dto.getTaJikoku());
			kintai().runCalculatedInfo(syukkinboDto);
			// 休暇申請とマージ
			margeHolidayRequest(syukkinboDto);
			vo.setFields(syukkinboDto);
			vo.setLabelInfo(syukkinboDto);
		}
		setLabelAttendanceInfo(DateUtil.convStringDateToDate(vo.getHidDate()));
	}
	
	/**
	 * 集計
	 * @throws Exception	例外処理が発生した場合
	 */
	private void runCalc() throws Exception {
		AttendanceQuitCardVo vo = (AttendanceQuitCardVo)getVo();
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		MSyukkinboDto dto = kintai().getSyukkinboInfo(vo.getHidKCode(), vo.getHidDate());
		vo.setDtoFields(dto);
		// 勤怠情報設定
		setCalcParam();
		// VOにセット
		kintai().runCalculatedInfo(dto);
		vo.setFields(dto);
		vo.setLabelInfo(dto);
		// 時間外警告対応
		setOverTimeCaution(vo.getHidKCode(), DateUtil.convStringDateToDate(vo.getHidDate()), dto.getZaJikan());
	}
	
	/**
	 * 自動計算メソッド
	 * @param dto		対象DTO
	 * @throws Exception	例外処理が発生した場合
	 */
	private void runAutoQuitCalc(MSyukkinboDto dto) throws Exception {
		// 勤怠情報設定
		setCalcParam();
		// 自動計算フラグ有りのみ
		//if (isAutoCalc) {
		// 日次自動計算フラグ
		if (isDailyAutoCalc) {
			// 勤怠項目計算
			kintai().runCalculatedInfo(dto);
		}
	}
	
}
